#ifndef CoCoA_DiagMatrix_H
#define CoCoA_DiagMatrix_H

//   Copyright (c)  2005  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoALib.  If not, see <http://www.gnu.org/licenses/>.


#include <cstddef>
//using std::size_t;
#include <vector>
//using std::vector;


namespace CoCoA
{

  class ConstMatrix; // forward declaration -- defined in matrix.H
  class RingElem;    // forward declaration -- defined in ring.H
  class matrix;      // forward declaration -- defined in matrix.H
  class ring;        // forward declaration -- defined in ring.H

  /*-----------------------------------------------------------------*/
  /** \include DiagMatrix.txt  */
  /*-----------------------------------------------------------------*/
  matrix NewDiagMatrix(const ring& R, std::size_t NumRows, std::size_t NumCols);
  matrix NewDiagMatrix(const ring& R, std::size_t NumRows, std::size_t NumCols, std::vector<RingElem> DiagEntries);
//???  matrix NewDiagMatrix(ConstMatrix M);

} // end of namespace CoCoA

#endif
